/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package AOPManager;

import Entity.*;
import BLL.*;

import java.text.DateFormat;

/**
 *处理日志相关的类
 * @author Icho
 */
public class LogManager {

    LogBLL _pvtLogBLL = new LogBLL();

    /**
     * 生成登录日志
     * @param prmUser 日志对应的用户对象
     */
    public void GenerateLoginMsg(TEST_User prmUser) {
        java.util.Date now = new java.util.Date();
        DateFormat day = DateFormat.getDateTimeInstance();
        TEST_Log tmpLog = new TEST_Log(prmUser, now, TEST_LogType.Login, null);
        _pvtLogBLL.GenerateNewLog(tmpLog);
    }

    /**
     * 生成注销日志
     * @param prmUser 日志对应的用户对象
     */
    public void GenerateLogoutMsg(TEST_User prmUser) {
        java.util.Date now = new java.util.Date();
        DateFormat day = DateFormat.getDateTimeInstance();
        TEST_Log tmpLog = new TEST_Log(prmUser, now, TEST_LogType.Logout, null);
        _pvtLogBLL.GenerateNewLog(tmpLog);
    }

    /**
     * 生成注册日志
     * @param prmUser 日志对应的用户对象
     */
    public void GenerateRegisterMsg(TEST_User prmUser) {
        java.util.Date now = new java.util.Date();
        DateFormat day = DateFormat.getDateTimeInstance();
        TEST_Log tmpLog = new TEST_Log(prmUser, now, TEST_LogType.register, null);
        _pvtLogBLL.GenerateNewLog(tmpLog);
    }

    /**
     * 生成上传文件日志
     * @param prmUser 日志对应的用户对象
     * @param prmFile 日志对应的文件对象
     */
    public void GenerateUploadMsg(TEST_User prmUser, TEST_File prmFile) {
        java.util.Date now = new java.util.Date();
        DateFormat day = DateFormat.getDateTimeInstance();
        TEST_Log tmpLog = new TEST_Log(prmUser, now, TEST_LogType.upload, prmFile.getFileID());
        _pvtLogBLL.GenerateNewLog(tmpLog);
    }

    /**
     * 生成下载文件的日志
     * @param prmUser 日志对应的用户对象
     * @param prmFile 日志对应的文件对象
     */
    public void GenerateDownloadMsg(TEST_User prmUser, TEST_File prmFile) {
        java.util.Date now = new java.util.Date();
        DateFormat day = DateFormat.getDateTimeInstance();
        TEST_Log tmpLog = new TEST_Log(prmUser, now, TEST_LogType.download, prmFile.getFileID());
        _pvtLogBLL.GenerateNewLog(tmpLog);
    }
}
