/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BLL;

import java.util.*;
import DAL.*;
import Entity.*;

/**
 *文件处理的业务逻辑层
 * @author Icho
 */
public class FileBLL {

    private UserBLL _pvtUserBLL = new UserBLL();
    private FileDAL _pvtFileDAL = new FileDAL();

    /**
     * 根据用户获取文件对象集合
     * @param prmUser 文件拥有者的用户对象
     * @return 文件集合
     */
    public List<TEST_File> GetFilesByUser(TEST_User prmUser) {
        List<TEST_File> tmpFiles = new LinkedList<TEST_File>();
        try {
            tmpFiles = _pvtFileDAL.SelectFilesByUser(prmUser);
            return tmpFiles;
        } catch (Exception ex) {
            return tmpFiles;
        }
    }

    /**
     * 根据文件名返回文件集合
     * @param prmFile 包含目标文件名的文件对象
     * @return 文件对象集合
     */
    public List<TEST_File> GetFilesByFileName(TEST_File prmFile) {
        List<TEST_File> tmpFiles = new LinkedList<TEST_File>();
        try {
            tmpFiles = _pvtFileDAL.SelectFilesByFileName(prmFile);
            return tmpFiles;
        } catch (Exception ex) {
            return tmpFiles;
        }
    }

    /**
     * 根据文件ID获取文件对象
     * @param prmUser 要获取文件对象的用户
     * @param prmFile 包含文件ID的文件对象
     * @return 根据文件ID返回的文件对象
     */
    public TEST_File GetFileByFileID(TEST_User prmUser, TEST_File prmFile) {
        try {
            if (_pvtUserBLL.CheckPassword(prmUser)) {
                return _pvtFileDAL.SelectFileByFileID(prmFile);
            }
            return null;
        } catch (Exception ex) {
            return null;
        }
    }

    /**
     * 新建文件对象
     * @param prmUser 文件拥有者的用户对象
     * @param prmFile 目标文件对象
     * @return 插入成功的文件对象或空
     */
    public TEST_File GenerateNewFile(TEST_User prmUser, TEST_File prmFile) {
        try {
            if (!_pvtUserBLL.CheckExistedUser(prmUser)) {
                return null;
            }
            return _pvtFileDAL.InsertNewFile(prmFile, prmUser);
        } catch (Exception ex) {
            return null;
        }
    }
}
