/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BLL;
import java.util.*;
import DAL.*;
import Entity.*;
/**
 *处理日志相关的业务逻辑层
 * @author Icho
 */
public class LogBLL {
    
    private LogDAL _pvtLogDAL=new LogDAL();
    private UserBLL _pvtUserBLL=new UserBLL();
    /**
     * 产生新的日志
     * @param prmLog 要插入的日志对象
     * @return 插入成功的日志对象
     */
    public TEST_Log GenerateNewLog(TEST_Log prmLog)
    {
        try
        {
            if(_pvtUserBLL.CheckExistedUser(prmLog.getUser()))
            {
                return _pvtLogDAL.InsertLog(prmLog);
            }
            return null;
        }
        catch(Exception ex)
        {
            return null;
        }
    }
    
    /**
     * 根据产生日志用户对象获取日志
     * @param prmUser 该日志对应的用户对象
     * @param Count 日志最大数量
     * @return 指定日志集合
     */
    public List<TEST_Log> GetLogsByUser(TEST_User prmUser,int Count)
    {
        List<TEST_Log> tmpLogs=new LinkedList<TEST_Log>();
        try
        {
            if(_pvtUserBLL.CheckExistedUser(prmUser))
            {
                tmpLogs= _pvtLogDAL.SelectLogsByUser(prmUser, Count);
            }
            return tmpLogs;
        }
        catch(Exception ex)
        {
            return tmpLogs;
        }
    }
    
    /**
     * 根据产生日志的时间获取日志
     * @param prmCreateTime 日志产生时间
     * @param Count 日志最大数量
     * @return 指定日志集合
     */
    public List<TEST_Log> GetLogsByCreateTime(Date prmCreateTime,int Count)
    {
        List<TEST_Log> tmpLogs=new LinkedList<TEST_Log>();
        try
        {
             tmpLogs= _pvtLogDAL.SelectLogsByCreateTime(prmCreateTime, Count);
             return tmpLogs;
        }
        catch(Exception ex)
        {
            return tmpLogs;
        }
    }

    /**
     * 根据日志的类型获取日志
     * @param prmLogType 日志类型
     * @param Count 日志最大数量
     * @return 指定日志集合
     */
    public List<TEST_Log> GetLogsByLogType(TEST_LogType prmLogType,int Count)
    {
         List<TEST_Log> tmpLogs=new LinkedList<TEST_Log>();
        try
        {
             tmpLogs= _pvtLogDAL.SelectLogsByLogType(prmLogType, Count);
             return tmpLogs;
        }
        catch(Exception ex)
        {
            return tmpLogs;
        }
    }
  
    /**
     * 根据日志记录对象获取日志
     * @param prmLogObject 日志记录对象
     * @param Count 日志最大数量
     * @return 指定日志集合
     */
    public List<TEST_Log> GetLogsByLogObject(Object prmLogObject,int Count)
    {
        List<TEST_Log> tmpLogs=new LinkedList<TEST_Log>();
        try
        {
             tmpLogs=_pvtLogDAL.SelectLogsByLogObject(prmLogObject, Count);
             return tmpLogs;
        }
        catch(Exception ex)
        {
            return tmpLogs;
        }
    }
    
}
