/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DAL;

import java.sql.*;
import java.util.*;
import Entity.*;

/**
 *文件对象处理的数据访问层
 * @author Icho
 */
public class FileDAL {

    private Connection _pvtConnection;
    private Statement _pvtStatement;

    /**
     * 根据用户对象得到该用户所有的文件
     * @param prmUser 用户对象
     * @return 文件集合
     * @throws Exception 产生的异常，由BLL处理
     */
    public List<TEST_File> SelectFilesByUser(TEST_User prmUser) throws Exception {

        try {
            OpenDB();
            List<TEST_File> tmpFiles = new LinkedList<TEST_File>();
            String tmpSelectStr = "Select * FROM FileTable WHERE FileCreator='" + prmUser.getUserName() + "';";
            ResultSet tmpRS = _pvtStatement.executeQuery(tmpSelectStr);
            while (tmpRS.next()) {
                String tmpFileName = tmpRS.getString("FileName");
                String tmpFileID = tmpRS.getString("FileID");
                String tmpFilePath = tmpRS.getString("FilePath");
                String tmpFileType = tmpRS.getString("FileType");
                long tmpFileSize = tmpRS.getLong("FileSize");
                TEST_File tmpFile = new TEST_File(tmpFileName, tmpFileID, tmpFilePath, tmpFileType, tmpFileSize);
                tmpFiles.add(tmpFile);
            }
            tmpRS.close();
            CloseDB();
            return tmpFiles;
        } catch (Exception ex) {
            CloseDB();
            throw ex;
        }
    }

    /**
     *  依据文件名得到的一个文件集合
     * @param prmFile 包含目标文件名的文件对象
     * @return 文件集合
     * @throws Exception 产生的异常，由BLL处理
     */
    public List<TEST_File> SelectFilesByFileName(TEST_File prmFile) throws Exception {

        try {
            OpenDB();
            List<TEST_File> tmpFiles = new LinkedList<TEST_File>();
            String tmpSelectStr = "Select * FROM FileTable WHERE FileName='" + prmFile.getFileName() + "';";
            ResultSet tmpRS = _pvtStatement.executeQuery(tmpSelectStr);
            while (tmpRS.next()) {
                String tmpFileName = tmpRS.getString("FileName");
                String tmpFileID = tmpRS.getString("FileID");
                String tmpFilePath = tmpRS.getString("FilePath");
                String tmpFileType = tmpRS.getString("FileType");
                long tmpFileSize = tmpRS.getLong("FileSize");
                TEST_File tmpFile = new TEST_File(tmpFileName, tmpFileID, tmpFilePath, tmpFileType, tmpFileSize);
                tmpFiles.add(tmpFile);
            }
            tmpRS.close();
            CloseDB();
            return tmpFiles;
        } catch (Exception ex) {
            CloseDB();
            throw ex;
        }
    }

    /**
     * 依据文件ID得到文件对象
     * @param prmFile 存放文件ID值的文件对象
     * @return 一个文件对象或空
     * @throws Exception 产生的异常，由BLL处理
     */
    public TEST_File SelectFileByFileID(TEST_File prmFile) throws Exception {

        try {
            OpenDB();
            TEST_File tmpFile = null;
            String tmpSelectStr = "Select * FROM FileTable WHERE FileID='" + prmFile.getFileID() + "';";
            ResultSet tmpRS = _pvtStatement.executeQuery(tmpSelectStr);
            if(tmpRS.next()) {
                String tmpFileName = tmpRS.getString("FileName");
                String tmpFileID = tmpRS.getString("FileID");
                String tmpFilePath = tmpRS.getString("FilePath");
                String tmpFileType = tmpRS.getString("FileType");
                long tmpFileSize = tmpRS.getLong("FileSize");
                 tmpFile = new TEST_File(tmpFileName, tmpFileID, tmpFilePath, tmpFileType, tmpFileSize);
            }
            tmpRS.close();
            CloseDB();
            return tmpFile;
        } catch (Exception ex) {
            CloseDB();
            throw ex;
        }
    }
    
    /**
     * 插入一个新的文件对象
     * @param prmFile 文件对象
     * @param prmUser 用户对象
     * @return 插入成功的文件对象或空
     * @throws Exception 产生的异常，由BLL处理
     */
    public TEST_File InsertNewFile(TEST_File prmFile,TEST_User prmUser)throws Exception{
        try
        {
            OpenDB();
            TEST_File tmpFile=null;
            String tmpInsertStr="INSERT INTO FileTable(FileID,FileName,FileType,FilePath,FileSize,FileCreator)"
                    + "VALUES('"+prmFile.getFileID()+"','"+prmFile.getFileName()+"','"+prmFile.getFileType()+"','"
                    + prmFile.getFilePath()+"',"+prmFile.getFileSize()+",'"+prmUser.getUserName()+"');";
            _pvtStatement.executeUpdate(tmpInsertStr);
            tmpFile=SelectFileByFileID(prmFile);
            CloseDB();
            return tmpFile;
        }
        catch(Exception ex){
            CloseDB();
            throw ex;
        }
    }
    
    /**
     * 根据文件ID删除文件
     * @param prmFile 要删除的文件对象
     * @throws Exception 产生的异常，由BLL处理
     */
    public void DeleteFileByFileID(TEST_File prmFile)throws Exception {
        try{
            OpenDB();
            String tmpDeleteStr="DELETE FROM FileTable WHERE FileID='"+prmFile.getFileID()+"'";
            _pvtStatement.executeUpdate(tmpDeleteStr);
            CloseDB();
        }
        catch(Exception ex){
            CloseDB();
            throw ex;
        }
    }

    /**
     * 打开数据库连接
     * @throws Exception
     */
    public void OpenDB() throws Exception {

        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            /**
             * 直接连接access文件。
             */
            String dburl = "jdbc:odbc:TEST_DB;";//需要设置数据源
            String user = "admin";
            String psw = "123456";
            Properties prop = new Properties();
            prop.put("charSet", "gb2312");
            prop.put("user", user);
            prop.put("password", psw);
            _pvtConnection = DriverManager.getConnection(dburl, prop);
            _pvtStatement = _pvtConnection.createStatement();
        } catch (Exception e) {
            System.out.println(e.toString() + "连接数据库失败！");
            throw new SQLException("连接数据库失败！" + e);
        }
    }

    /**
     * 关闭数据库连接
     */
    public void CloseDB() {
        try {
            if (_pvtStatement != null) {
                _pvtStatement.close();
                _pvtStatement = null;
            }
            if (_pvtConnection != null) {
                _pvtConnection.close();
                _pvtConnection = null;
            }
        } catch (Exception e) {
        }

    }
}
