/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DAL;

import Entity.TEST_User;

import java.util.*;
import java.sql.*;

/**
 *控制用户对象的数据访问层
 * @author Icho
 */
public class UserDAL {

    private Connection _pvtConnection;
    private Statement _pvtStatement;

    /**
     * 根据用户对象插入新用户的数据访问操作
     * @param prmUser 需要插入的新的用户对象
     * @return 返回插入的用户对象
     * @throws Exception
     */
    public TEST_User InsertNewUser(TEST_User prmUser) throws Exception {
        //数据访问操作，插入新用户后返回插入的用户对象，插入失败则抛出异常
        try {
            OpenDB();
            _pvtStatement = _pvtConnection.createStatement();
            String tmpInsertStr = "INSERT INTO UserTable(Username,Password,PersonalInfo)"
                    + "VALUES('" + prmUser.getUserName() + "','" + prmUser.getPassword() + "','"
                    + prmUser.getPersonalInfo() + "');";
            int flag=_pvtStatement.executeUpdate(tmpInsertStr);
            if(flag==1){
                //缓解数据库更新延迟问题
                Thread.sleep(1000);
            }
            TEST_User tmpInsertedUser = SelectUserByUserName(prmUser);
            CloseDB();
            return tmpInsertedUser;
        } catch (Exception ex) {
            CloseDB();
            throw ex;
        }
    }

    /**
     * 根据用户名获取用户对象的数据访问操作
     * @param prmUser 根据该用户的用户名从数据库中选择对应用户的对象
     * @return 新的用户对象
     * @throws Exception
     */
    public TEST_User SelectUserByUserName(TEST_User prmUser) throws Exception {
        //数据访问操作，获取用户名，密码，并实例化TEST_User类，返回该类。
        try {
            OpenDB();
            TEST_User tmpUser = null;
            String tmpSelectStr = "SELECT Username,Password,PersonalInfo "
                    + "FROM UserTable "
                    + "WHERE Username='" + prmUser.getUserName() + "';";
            ResultSet tmpRS = _pvtStatement.executeQuery(tmpSelectStr);
            if (tmpRS.next()) {
                tmpUser = new TEST_User(tmpRS.getString(1), tmpRS.getString(2), tmpRS.getString(3));
            }
            tmpRS.close();
            CloseDB();
            return tmpUser;
        } catch (Exception ex) {
            CloseDB();
            throw ex;
        }



    }

    /**
     * 更新用户个人信息的数据访问操作
     * @param prmUser 该用户对象
     * @param prmNewPersonalInfo 新的用户信息
     * @return 更新后的用户对象
     * @throws Exception
     */
    public TEST_User UpdateUserPersonalInfo(TEST_User prmUser, String prmNewPersonalInfo) throws Exception {
        String tmpUserName = prmUser.getUserName();
        String tmpPassword = prmUser.getPassword();
        //提取该用户对象的信息，进行数据更新操作，如数据库的更新等等
        try {
            OpenDB();
            String tmpUpdateStr = "UPDATE UserTable SET PersonalInfo='"
                    + prmNewPersonalInfo + "' WHERE Username='"
                    + prmUser.getUserName() + "';";
            _pvtStatement.executeUpdate(tmpUpdateStr);
            //更新完成后，返回被更新的用户对象,失败则抛出异常
            TEST_User tmpUpdatedUser = SelectUserByUserName(prmUser);
            CloseDB();
            return tmpUpdatedUser;
        } catch (Exception ex) {
            CloseDB();
            throw ex;

        }
    }

    /**
     * 更新用户密码的数据访问操作
     * @param prmUser 该用户对象
     * @param prmNewPassword 新的用户密码
     * @return 更新密码后的用户对象
     * @throws Exception
     */
    public TEST_User UpdateUserPassword(TEST_User prmUser, String prmNewPassword) throws Exception {
        String tmpUserName = prmUser.getUserName();
        String tmpPersonalInfo = prmUser.getPersonalInfo();
        //提取该用户对象的信息，进行数据更新操作，如数据库的更新等等
        try {
            OpenDB();

            String tmpUpdateStr = "UPDATE UserTable SET Password='"
                    + prmNewPassword + "' WHERE Username='" + prmUser.getUserName() + "';";
            _pvtStatement.executeUpdate(tmpUpdateStr);
            //更新完成后，返回被更新的用户对象,失败则抛出异常
            TEST_User tmpUpdatedUser = SelectUserByUserName(prmUser);
            CloseDB();
            return tmpUpdatedUser;
        } catch (Exception ex) {
            CloseDB();
            throw ex;
        }
    }

    /**
     * 删除用户的数据访问操作
     * @param prmUser 对应的用户
     * @throws Exception
     */
    public void DeleteUser(TEST_User prmUser) throws Exception {
        //数据访问操作，删除该用户，若不成功则抛出异常
        try {

            OpenDB();
            String tmpDeleteStr = "DELETE FROM UserTable WHERE Username='"
                    + prmUser.getUserName() + "';";
            _pvtStatement.executeUpdate(tmpDeleteStr);
            CloseDB();
        } catch (Exception ex) {
            CloseDB();
            CloseDB();
        }
    }

    /**
     * 打开数据库连接
     * @throws Exception
     */
    public void OpenDB() throws Exception {

        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            /**
             * 直接连接access文件。
             */
            String dburl = "jdbc:odbc:TEST_DB;";//需要设置数据源
            String user = "admin";
            String psw = "123456";
            Properties prop = new Properties();
            prop.put("charSet", "gb2312");
            prop.put("user", user);
            prop.put("password", psw);
            _pvtConnection = DriverManager.getConnection(dburl, prop);
            _pvtStatement=_pvtConnection.createStatement();
        } catch (Exception e) {
            System.out.println(e.toString() + "连接数据库失败！");
            throw new SQLException("连接数据库失败！" + e);
        }
    }

    /**
     * 关闭数据库连接
     */
    public void CloseDB() {
        try {
            if (_pvtStatement != null) {
                _pvtStatement.close();
                _pvtStatement = null;
            }
            if (_pvtConnection != null) {
                _pvtConnection.close();
                _pvtConnection = null;
            }
        } catch (Exception e) {
        }

    }
}
